'use strict';

/**
 * Types object.
 */

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var types = {};

/**
 * Checks the value is an integer.
 *
 * @param {*} value
 * @return {boolean}
 * @api private
 */
types.integer = function (value) {
  return typeof value === 'number' && Math.floor(value) === value;
};

/**
 * Checks the value is an number.
 *
 * @param {*} value
 * @return {boolean}
 * @api private
 */
types.number = function (value) {
  return typeof value === 'number';
};

/**
 * Checks the value is an boolean.
 *
 * @param {*} value
 * @return {boolean}
 * @api private
 */
types.boolean = function (value) {
  return typeof value === 'boolean';
};

/**
 * Checks the value is a string.
 *
 * @param {*} value
 * @return {boolean}
 * @api private
 */
types.string = function (value) {
  return typeof value === 'string';
};

/**
 * Checks the value is an array.
 *
 * @param {*} value
 * @return {boolean}
 * @api private
 */
types.array = function (value) {
  return Array.isArray(value);
};

/**
 * Checks the value is a plain JS object.
 *
 * @param {*} value
 * @return {boolean}
 * @api private
 */
types.object = function (value) {
  return (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && value && !Array.isArray(value);
};

/**
 * Expose types.
 */
module.exports = types;